       //*******************************************************************    
       // SQL2XLXR - Create Excel from SQL                                      
       //*******************************************************************    
                                                                                
       CTL-OPT DFTACTGRP(*NO) ACTGRP('XLXR') BNDDIR('QC2LE') DEBUG              
               COPYRIGHT('giuseppe.costagliola@gmail.com - 2017');              
                                                                                
       //-------------------------------------------------------------------    
       // Parameters                                                            
       //-------------------------------------------------------------------    
       DCL-PI SQL2XLSXR;                                                        
         pSQLSTMT  Char(5000);                                                  
         pTOXLS    Char(120);                                                   
         pFROMXLS  Char(120);                                                   
         pSQLID    Char(120);                                                   
       END-PI;                                                                  
                                                                                
      /COPY QSYSINC/QRPGLESRC,QUSEC                                             
     DQUSED01                        60                                         
                                                                                
       // Stream file APIs -------------------------------------------------.   
       DCL-PR unlink Int(10) Extproc(*DCLCASE);                                 
         Path  Pointer Value Options(*string);                                  
       END-PR;                                                                  
       DCL-PR open Int(10) Extproc(*DCLCASE);                                   
         Path  Pointer Value Options(*string);                                  
         oFlag Int(10) Value;                                                   
         Mode  Uns(10) Value Options(*NOPASS);                                  
         CCSID Uns(10) Value Options(*NOPASS);                                  
       END-PR;                                                                  
       DCL-S O_RDONLY     Int(10) Inz(1);                                       
       DCL-S O_CREAT      Int(10) Inz(8);                                       
       DCL-S O_WRONLY     Int(10) Inz(2);                                       
       DCL-S O_TRUNC      Int(10) Inz(64);                                      
       DCL-S O_CODEPAGE   Int(10) Inz(8388608);                                 
       DCL-S S_IRWXU      Int(10) Inz(448);                                     
       DCL-S S_IROTH      Int(10) Inz(4);                                       
       DCL-S S_IRWXO      Int(10) Inz(7);                                       
       DCL-PR write Int(10) Extproc(*DCLCASE);                                  
         FileDesc  Int(10) Value;                                               
         buffer_   Pointer Value;                                               
         nbyte     Int(10) Value;                                               
       END-PR;                                                                  
       DCL-PR close Int(10) Extproc(*DCLCASE);                                  
         FileDesc  Int(10) Value;                                               
       END-PR;                                                                  
                                                                                
       DCL-S fd         Int(10);                                                
       DCL-S bytesw     Int(10);                                                
                                                                                
       // Local procedures -------------------------------------------------    
       DCL-PR RftSQLstmt   LikeDs(SQL);                                         
         SQLstmt Value Like(pSQLstmt);                                          
       END-PR;                                                                  
                                                                                
       DCL-PR CrtSQLstmf   Like(SQL.id);                                        
         JobId   Value Like(JobNbr);                                            
       END-PR;                                                                  
                                                                                
       DCL-PR WrtSQLstmt;                                                       
         pSQL    Value LikeDs(SQL);                                             
       END-PR;                                                                  
                                                                                
       DCL-PR FixPath Char(120);                                                
         Path    Char(120);                                                     
       END-PR;                                                                  
                                                                                
       DCL-PR GetCCSID like(CCSID);                                             
       END-PR;                                                                  
       DCL-S CCSID   Int(10);                                                   
                                                                                
       DCL-PR Ebcdic2Ascii;                                                     
         From    Pointer Value;                                                 
         Len     Int(10) Value;                                                 
       END-PR;                                                                  
                                                                                
       DCL-PR GetErrInfo Char(128);                                             
       END-PR;                                                                  
                                                                                
       DCL-PR SndPgmMsg;                                                        
         Type       Char(10)  Value;                                            
         Function   Char(20)  Value;                                            
         MsgId      Char(7)   Value;                                            
         Msg        Char(128) Value;                                            
       END-PR;                                                                  
                                                                                
       // Local variables --------------------------------------------------    
       DCL-S Msg      Char(128);                                                
       DCL-S Path     Char(128);                                                
       DCL-S Buffer   Int(10);                                                  
                                                                                
       // Local structures -------------------------------------------------    
       DCL-DS SQL Qualified;                                                    
         Stmt    Like(pSQLSTMT);                                                
         Length  Int(10);                                                       
         Id      Char(120);                                                     
       END-DS;                                                                  
                                                                                
       // Program status area                                                   
       DCL-DS *N PSDS;                                                          
         JobNbr   Char(6) Pos(264);                                             
       END-DS;                                                                  
                                                                                
       //*******************************************************************    
       // MAIN                                                                  
       //*******************************************************************    
                                                                                
       // Reformat the SQL statement                                            
       SQL = RftSQLstmt (pSQLSTMT);                                             
                                                                                
       // Create the SQLstatement stream file                                   
       SQL.id = CrtSQLstmf (JobNbr);                                            
                                                                                
       // Write the SQL statement                                               
       WrtSQLstmt (SQL);                                                        
                                                                                
       // Fix path names                                                        
       Path = FixPath (pTOXLS);                                                 
       pTOXLS = Path;                                                           
       Path = FixPath (pFROMXLS);                                               
       pFROMXLS = Path;                                                         
                                                                                
       // Return SQL stream file ID                                             
       pSQLID = SQL.Id;                                                         
       *INLR = *ON;                                                             
       Return;                                                                  
                                                                                
       //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       // Reformat the SQL statement                                            
       //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       DCL-PROC RftSQLstmt;                                                     
       DCL-PI *N LikeDs(SQL);                                                   
         SQLstmt  Value Like(pSQLstmt);                                         
       END-PI;                                                                  
                                                                                
       DCL-DS NewSQL LikeDs(SQL);                                               
       DCL-S j Int(5);                                                          
                                                                                
       NewSQL.Stmt = SQLstmt;                                                   
       NewSQL.Length = %len(%trim(SQLStmt));                                    
       For j = 1 to NewSQL.Length;                                              
         Select;                                                                
           When %subst(NewSQL.Stmt:j:1) = '"';                                  
             %subst(NewSQL.Stmt:j:1) = '''';                                    
           When %subst(NewSQL.Stmt:j:1) = '[';                                  
             %subst(NewSQL.Stmt:j:1) = '"';                                     
           When %subst(NewSQL.Stmt:j:1) = ']';                                  
             %subst(NewSQL.Stmt:j:1) = '"';                                     
         EndSl;                                                                 
       EndFor;                                                                  
                                                                                
       // return SQL structure                                                  
       Return NewSQL;                                                           
                                                                                
       END-PROC RftSQLstmt;                                                     
                                                                                
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
      // Create an empty SQL parameter file                                     
      //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       DCL-PROC CrtSQLstmf;                                                     
       DCL-PI *N like(SQL.id);                                                  
         Jobid  Char(6) Value;                                                  
       END-PI;                                                                  
                                                                                
       DCL-S FileName  Like(SQL.id);                                            
       DCL-S ErrMsg    Char(128);                                               
                                                                                
       FileName = '/tmp/SQLID' + %trim(JobId) + '.dat';                         
       FileName = %TRIM(FileName) + X'00';                                      
                                                                                
       // Check whether stream file exists or not.                              
       fd = open(%Addr(FileName) : 1);                                          
                                                                                
       // If Stream file exists, then unlink the stream file                    
       If fd <> -1;                                                             
         If close(fd) = -1;                                                     
           ErrMsg = 'close() failed. ' + geterrinfo;                            
         EndIf;                                                                 
         If unlink(%Addr(Filename)) = -1;                                       
           ErrMsg = 'unlink() failed. ' + geterrinfo;                           
         EndIf;                                                                 
       EndIf;                                                                   
                                                                                
       // If errors exit                                                        
       If ErrMsg <> ' ';                                                        
         SndPgmMsg ('*ESCAPE':'CrtSQLstmf': ' ' : ErrMsg);                      
       EndIf;                                                                   
                                                                                
       // Open(Create) stream file                                              
       fd = open(%Addr(Filename)                                                
            : O_CREAT + O_WRONLY + O_TRUNC + O_CODEPAGE                         
            : S_IRWXU + S_IROTH : 819);                                         
       If fd = -1;                                                              
         ErrMsg = 'open() failed. ' + geterrinfo;                               
       EndIf;                                                                   
                                                                                
       // If errors exit                                                        
       if ErrMsg <> ' ';                                                        
         SndPgmMsg ('*ESCAPE':'CrtSQLstmt': ' ' : ErrMsg);                      
       EndIf;                                                                   
                                                                                
       // Return SQLid                                                          
       Return Filename;                                                         
                                                                                
       END-PROC CrtSQLstmf;                                                     
                                                                                
       //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       // Write the statement                                                   
       //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       DCL-PROC WrtSQLstmt;                                                     
       DCL-PI *N;                                                               
         pSql  Value LikeDs(SQL);                                               
       END-PI;                                                                  
                                                                                
       DCL-S ErrMsg  Char(128);                                                 
                                                                                
       // convert to ascii                                                      
       Ebcdic2Ascii (%addr(pSQL.Stmt):pSQL.Length);                             
                                                                                
       // write data to stream file                                             
       bytesw = write(fd:%addr(pSQL.stmt):pSQL.Length);                         
       If bytesw <> pSQL.Length;                                                
         ErrMsg = 'write() failed. ' + geterrinfo;                              
       EndIf;                                                                   
                                                                                
       // close stream file                                                     
       If close(fd) = -1;                                                       
         ErrMsg = 'close() failed. ' + geterrinfo;                              
         SndPgmMsg ('*ESCAPE':'CloSQLstmt': ' ' : ErrMsg);                      
       EndIf;                                                                   
                                                                                
       END-PROC WrtSQLstmt;                                                     
                                                                                
       //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       // Fix Path names                                                        
       //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       DCL-PROC FixPath;                                                        
       DCL-PI *N Char(120);                                                     
         Path  Char(120);                                                       
       END-PI;                                                                  
                                                                                
       // put backslash in IFS style                                            
       Return %scanrpl('\':'/':%trim(Path));                                    
                                                                                
       END-PROC FixPath;                                                        
                                                                                
       //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       // Get Job CCSID                                                         
       //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       DCL-PROC GetCCSID;                                                       
       DCL-PI *N Like(CCSID);                                                   
       END-PI;                                                                  
                                                                                
       DCL-PR QUSRJOBI ExtPgm;                                                  
         jobi0400     Char(1024) Options(*varsize);                             
         jobiBytes    Int(10)  Const;                                           
         jobiFormat   Char(10) Const;                                           
         jobiJobName  Char(26) Const;                                           
         jobiJobInt   Char(16) Const;                                           
       END-PR;                                                                  
                                                                                
       DCL-DS jobi0400;                                                         
         CCSID Int(10) Pos(373);                                                
       END-DS;                                                                  
                                                                                
       // get CCSID                                                             
       QUSRJOBI (jobi0400:%len(jobi0400):'JOBI0400':'*':' ');                   
       Return CCSID;                                                            
                                                                                
       END-PROC GetCCSID;                                                       
                                                                                
       //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       // Ebcdic -> Ascii                                                       
       //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       DCL-PROC Ebcdic2Ascii;                                                   
       DCL-PI *N;                                                               
         From  Pointer Value;                                                   
         Len   Int(10) Value;                                                   
       END-PI;                                                                  
                                                                                
       // Convert a Graphic Character String API                                
       DCL-PR CDRCVRT ExtPgm;                                                   
         CCSID1   Int(10) Const;                                                
         ST1      Int(10) Const;                                                
         S1       Char(256) Const;                                              
         L1       Int(10) Const;                                                
         CCSID2   Int(10) Const;                                                
         ST2      Int(10) Const;                                                
         GCCASN   Int(10) Const;                                                
         L2       Int(10) Const;                                                
         S2       Char(256) Const;                                              
         L3       Int(10) Const;                                                
         L4       Int(10) Const;                                                
         FB       Char(12);                                                     
       END-PR;                                                                  
                                                                                
       // xlateb MI                                                             
       DCL-PR xlateb ExtProc('_XLATEB');                                        
         *N Pointer Value;                                                      
         *N Pointer Value;                                                      
         *N Uns(10) Value;                                                      
       END-PR;                                                                  
                                                                                
       // conversion tables and CDRCVRT rtn flds                                
       DCL-S TblEbcdic   Char(256) Inz(*allx'ff');                              
       DCL-S TblAscii    Char(256) Inz(*allx'ff') static;                       
       DCL-S L3          Int(10);                                               
       DCL-S L4          Int(10);                                               
       DCL-S FB          Char(12);                                              
                                                                                
       // conversion binary - hex                                               
       DCL-DS xValue;                                                           
         bValue  Uns(3) Pos(1);                                                 
       END-DS;                                                                  
                                                                                
       DCL-S CCSID   Int(10);                                                   
       DCL-S setTable  Ind Static;                                              
                                                                                
       If not setTable;                                                         
         // get CCSID                                                           
         CCSID = GetCCSID();                                                    
         // create a conversion table                                           
         For bValue = 0 to 254;                                                 
           %subst(TblEbcdic:bValue+1:1) = xValue;                               
         EndFor;                                                                
         CDRCVRT (CCSID:0:TblEbcdic:256:819:0:0:256:TblAscii:L3:L4:FB);         
         setTable = *on;                                                        
       EndIf;                                                                   
                                                                                
       // convert                                                               
       xlateb (From:%addr(TblAscii):Len);                                       
                                                                                
       END-PROC Ebcdic2Ascii;                                                   
                                                                                
       //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       // Get C error data                                                      
       //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       DCL-PROC geterrinfo;                                                     
       DCL-PI *N Char(128) END-PI;                                              
       DCL-PR geterrno Pointer EXTPROC('__errno') END-PR;                       
       DCL-PR strerror Pointer EXTPROC('strerror');                             
          errno Int(10) VALUE;                                                  
       END-PR;                                                                  
                                                                                
       DCL-S errnum Int(10) BASED(errnum_p);                                    
                                                                                
       errnum_p = geterrno;                                                     
       Return %TRIM(%EDITC(errnum : '3')) + ' : ' +                             
              %STR(strerror(errnum));                                           
                                                                                
       END-PROC geterrinfo;                                                     
                                                                                
       //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       // Send Program Message                                                  
       //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++    
       DCL-PROC SndPgmMsg;                                                      
       DCL-PI *N;                                                               
         msgType  Char(10)  VALUE;                                              
         function Char(20)  VALUE;                                              
         msgId    Char(7)   VALUE;                                              
         msgErr   Char(128) VALUE;                                              
       END-PI;                                                                  
                                                                                
       DCL-PR QMHSNDPM ExtPgm;                                                  
         MessageId     Char(7)   const;                                         
         MessageFile   Char(20)  const;                                         
         MessageData   Char(512) const options(*varsize);                       
         MessageDataL  Int(10)   const;                                         
         MessageType   Char(10)  const;                                         
         CallStkEntry  Char(128) const options(*varsize);                       
         CallStkCount  Int(10)   const;                                         
         MessageKey    Char(4)   const;                                         
         ApiError      Char(120) options(*varsize);                             
       END-PR;                                                                  
                                                                                
       DCL-S idMsg   Char(7);                                                   
       DCL-S errMsg  Char(128);                                                 
       If msgId <> ' ';                                                         
         idMsg  = msgId;                                                        
         errMsg = msgErr;                                                       
       Else;                                                                    
         If msgType = '*ESCAPE';                                                
           idMsg  = 'CPF9898';                                                  
           errMsg = 'Errore ' + %trimr(function) + ' : ' + msgErr;              
         Else;                                                                  
           errMsg = msgErr;                                                     
         EndIf;                                                                 
       EndIf;                                                                   
                                                                                
       QMHSNDPM (idMsg: 'QCPFMSG   QSYS' : errMsg : %len(errMsg) :              
                 msgType : '*CTLBDY' : 1 : ' ' : QUSEC);                        
                                                                                
       END-PROC SndPgmMsg;                                                      
